#!/usr/bin/perl
#
# THIS SOFTWARE IS FREE SOFTWARE! IT IS LICENCED UNDER THE GNU PUBLIC LICENCE
#  (c) Dr. Peter Sebbel alias doc (vdrsync.gmx. net) 
# 
# This script ist just a demo or a test for a concept. Please provide feedback if you like it or want to reuse it
#
# Cheers
# doc


use strict;
use warnings;

# PLEASE ADJUST VALUES HERE
my $interval         = 30;        # Check GOPs (ca 12 Pictures) every nn seconds
my $gops2check  	 = 3;         # check nn GOPs
my $min_movie_length = 180;       # minmal length for a movie bit to be accepted in seconds
my $min_ad_length    = 30;        # minmal length for am advertisement bit in seconds, NOT USED
my $final_check_gops = 20;        # number of GOPS to check for the last analysis

my $mspeed           = 100;       # this is the speed parameter for mplayer, might be too fast on your machine



##########################################################################
# script Start, you are welcome to mess araound here, but not adivised to do so ;)
##########################################################################

my @files;
my @file_handles;
my @file_sizes;
my $marks_file;
my $summary_file;
my $index_file;
my $IFH;
my @marks;
my @ticks;
my $total_input;
my $EOF = 0;
my $filepos = 0;
my @chunk_list;
my $BITFH; 
my %Iframes;
my @Iframe_list;
my $gop_chunk;
my %final_Y_hash;
my @result_list;
my $frameno;
my $movie_bottom = 0;
my $bottom_freq = 0;
my $total = 0;
my $DIR; 

my $indir = shift @ARGV;


if (! $indir)
	{
	print "USAGE: bordermarks.pl PATH_TO_YOUR_RECORDING\n";
	print " Do not supply single files, just the full path\n";
	exit;
	}
print "Analysing recording at $indir\n";



# check the files in the Dir 
get_file_list();
# If an exisiting marks file is found, it read
read_marks_file();
# THIS SCRIPT NEEDS A VALID index.vdr
read_index_file();
 
print "First Iframe is  $Iframe_list[0], last is $Iframe_list[-1]\n";

my $duration = $Iframe_list[-1] * 0.04;
my $samples = int($duration / $interval);

print "The movie has a length of $duration sec and we take a total of $samples samples, every $interval secs\n";


open RF, ">./results.txt" || die "Can not open outfile\n";

for (my $i = 1; $i < $samples; $i++)
	{
	($gop_chunk, $frameno) = get_gop($interval * $i, $gops2check);
	#print "got a gop with a length of " . length($gop_chunk) ."\n";
	$result_list[$i] = get_chunk_border(\$gop_chunk) ;
	print RF "--------------- at " . ($i * $interval) . " sec ------------------\n";
	foreach (@{$result_list[$i]})
		{
		my ($bottom_value, $freq) = split/ : /,$_;
		print "$freq times:  $bottom_value in sample $i of $samples at " . ($interval * $i) ." secs\n";
		print RF "$freq times:  $bottom_value in sample $i at " . ($interval * $i) ." secs\n";
		if (! $final_Y_hash{$bottom_value})
			{
			$final_Y_hash{$bottom_value} = $freq;
			}
		else
			{
			$final_Y_hash{$bottom_value} += $freq;
			}
		}
	}

print "we got " . (scalar(@result_list)) . " entires in the final list\n";
foreach (keys(%final_Y_hash))
	{
	print "For bottom border $_ we got $final_Y_hash{$_}\n";
	if ($final_Y_hash{$_} > $bottom_freq)
		{
		$movie_bottom = $_;
		$bottom_freq = $final_Y_hash{$_};
		$total += $final_Y_hash{$_};
		}
	}

print "we got $bottom_freq for value $movie_bottom, that is $bottom_freq of $total or " . ($bottom_freq / $total * 100) ." percent\n";
if (($bottom_freq / $total * 100) > 50)
	{
	print "It looks really good for the value of $movie_bottom\n";
	}
else
	{
	die "les than 50% of all samples have the same value, exiting\n";
	}


my @movie_chunks;
my $cunk_length;
my $movie_start = -1;
my $ad_start = -1;
my $mov_ad_status = -1;


for (my $i = 1; $i < $samples; $i++)
	{
	my $ad_frames = 0;
	my $movie_frames = 0;
	my @sample_results = @{$result_list[$i]};
	
	for (my $j = 0; $j < scalar(@sample_results); $j++)
		{
		my($value, $freq) = split/ : /,$result_list[$i][$j];
	
		if ($value < $movie_bottom + 10)
			{
			$movie_frames += $freq;
			}
		else
			{
			$ad_frames += $freq;
			}
		}
		print "we got $movie_frames frames with a correct bottom border, and $ad_frames with smaller one\n";
		if ($movie_frames > $ad_frames)
			{
			print "therefore, this is a movie bit\n";
			if ($mov_ad_status ne "mov")
				{
				$mov_ad_status = "mov";
				$movie_start = $i;
				push @movie_chunks,"AD $ad_start " . ($i-1)  if ($ad_start ne "-1");
				}
			}
		else
			{
			print "therefore, this is an ad bit\n";
			if ($mov_ad_status ne "ad")
				{
				$mov_ad_status = "ad";
				$ad_start = $i;
				push @movie_chunks,"MOVIE $movie_start " . ($i-1)  if ($movie_start ne "-1");
				}
			}
	}
	
	
my $finished = 1;
while ($finished)
	{
	print "trying to remove movie bits that are too small...\n";
	$finished = check_movie_chunks();
	#foreach (@movie_chunks)
	#	{
	#	print "Corrected: $_\n";
	#	}
	}

my @final_marks;
		
if ($movie_chunks[0] =~ /~MOVIE/)
	{
	push @final_marks, "1";
	$mov_ad_status = "mov";
	}
else 
	{
	$mov_ad_status = "ad";
	}
	
	
	
foreach(@movie_chunks)
	{
	my $i = 0;
	my $found_border = 0;
	my ($status, $first, $last) = split / /, $_;
	print "last is $last, status is $status\n";
	my $start_time = ($last * $interval);
	print "starting to look for transition at $start_time\n";
	my $start_frame = $start_time * 25;
	print "need to start at $start_frame\n";
	($start_frame, my $dummy) =  find_GOP_offset($start_frame);
	$start_time = $start_frame / 25;
	print "Real start at $start_time, real start_frame $start_frame\n";
	
	while (! $found_border)
		{
		if ($i * 0.5 > $interval) 
			{
			print "something nasty going on skipping this mark\n";
			$found_border = 1;
			}
		my ($gop_chunk, $current_frame) = get_gop(($start_time + ($i * 0.5)), 2);
		
		$i++;
		#print "got a gop_chunk of size " . length($gop_chunk) . "\n";
	
		my @result_list = @{ get_chunk_border(\$gop_chunk) };
		
		my $movie_test = is_movie(\@result_list);
		if ($movie_test == -1)
			{
			print "skipped this gop, could not be analysed\n";
			next;
			}
		
		if (is_movie(\@result_list))
			{
			if ($status eq "AD")
				{
				my ($test_chunk, $dummy_frame) = get_gop(($current_frame * 0.04), $final_check_gops);
				my @test_results = @{ get_chunk_border(\$test_chunk) };
				if (is_movie(\@test_results))
					{
					push @final_marks, $current_frame;
					$found_border = 1;
					print "FOUND MOVIE after $status i is $i at $current_frame\n";
					next;
					}
				}
			}
		else
			{
			if ($status eq "MOVIE")
				{
				my ($test_chunk, $dummy_frame) = get_gop(($current_frame * 0.04), 20);
				my @test_results = @{ get_chunk_border(\$test_chunk) };
				if (! is_movie(\@test_results))
					{
					push @final_marks, $current_frame;
					print "FOUND AD after $status i is $i at $current_frame\n";
					$found_border = 1;
					next;
					}
				}
			}	
		print "No border detected at frame $current_frame, continuing to look for change from $status at GOP after $current_frame  \n";
		}
	}

open FF, ">./detected_marks.vdr" || die "Can not open Final result file: $!\n";
foreach(@final_marks)
	{
	my $secs = $_ * 0.04;
	print "got secs $secs\n";
	my $hours = int($secs  / 3600);
	my $min_secs = ($secs - $hours * 3600);
	my $min = int (($secs - 3600 * $hours) / 60);
	$secs -= ($hours * 3600 + $min * 60);
	printf "set a mark at frame $_, that is %1u:%02u:%05.02f\n", $hours, $min, $secs;
	printf FF "%1u:%02u:%05.02f\n", $hours, $min, $secs;
	}
close FF;
	
	
sub is_movie
	{
	my @list = @{ shift @_};
	my $movie_frames = 0;
	my $ad_frames = 0;
	
	foreach (@list)
		{
		my($value, $freq) = split/ : /,$_;
		
		if ($value < $movie_bottom + 10)
			{
			$movie_frames += $freq;
			}
		else
			{
			$ad_frames += $freq;
			}
		}
	if (($movie_frames + $ad_frames) < 5)
		{
		return -1;
		}
	if ($movie_frames > $ad_frames)
		{
		return 1;
		}
	else
		{
		return 0;
		}
	}
	

sub get_chunk_border
	{
	
	my $chunk = ${shift @_ };
	
	open MPLAYER, " |  mplayer -  -vo null -ao null -speed $mspeed -vop cropdetect 2>/dev/null > crop.out" || die "Can not open mplayer: $!\n";
	print MPLAYER $chunk;
	close MPLAYER;
	
	open IF, "<./crop.out" || die "Can not open infile\n";
	
	my $start = 0;
	my %crophash;
	my $input;
	while (<IF>)
		{
		$input .= $_;
		}
	while ($input =~ /crop area: X: \d+\.\.\d+  Y: \d+\.\.(\d+)/g)
		{
		#print "matched $1 in $&\n";
		#If we match something smaller than 250, probably we had a black screen. That has to be skipped
		if ($1 < 50) {next}
		if (! $crophash{$1})
			{
			$crophash{$1} = 1;
			}
		else
			{
			$crophash{$1}++;
			}
		}
	close IF;
	my $j = 0;
	my @return_list;
	foreach (keys(%crophash))
		{
		$return_list[$j++]= "$_ : $crophash{$_}";
		}
	#print "return_lsit has " . scalar(@return_list) . " elements\n";
	#foreach (@return_list)
	#	{
	#	print "Got $_\n";
	#	}
	return \@return_list;
	}

sub check_movie_chunks
	{
	#print "got " . scalar(@movie_chunks) . " entires in the list\n";
	for (my $i = 1; $i < scalar(@movie_chunks)-1; $i++)
		{
		my ($status, $chunk_start, $chunk_end) = split / /, $movie_chunks[$i];
		my $length  = $chunk_end - $chunk_start; 
		print "Checking: $movie_chunks[$i] with length $length\n";
		if (($status eq "MOVIE") && ($length < ($min_movie_length/$interval)))
			{
			print "False setection, movie to shoort, should be deleted\n";
			my @new_entry;
			my ($b_status, $b_chunk_start, $b_chunk_end) = split / /, $movie_chunks[$i-1];
			my ($a_status, $a_chunk_start, $a_chunk_end) = split / /, $movie_chunks[$i+1];
			if ($i > 1)
				{
				(@new_entry) = @movie_chunks[0 .. ($i-2)];
				}
			push @new_entry, "$b_status $b_chunk_start $a_chunk_end";
			(my @old_entries) = (@movie_chunks[($i+1) .. (scalar(@movie_chunks)-1)]);
			
			
			(@movie_chunks) = (@new_entry , @movie_chunks[($i+2) .. (scalar(@movie_chunks)-1)]);
			return 1;
			}
		}
	return 0;
	}

sub get_file_list
	{
	opendir $DIR, $indir || die "Can not open $indir $!\n";
	print "trying to open $indir\n";
	if (! $DIR)
		{
		die "did not get a handle back\n";
		}
	my @allfiles =   grep { ! /^\./  } readdir $DIR;
	@files =   sort (grep { /\d{3}.vdr$/  } @allfiles);

	$summary_file = $indir . "summary.vdr" if (-e "$indir/summary.vdr");
	$marks_file = $indir . "marks.vdr" if (-e "$indir/marks.vdr");
	$index_file = $indir . "index.vdr" if (-e "$indir/index.vdr");
	
	foreach (@files)
		{
		$_ = $indir . $_;
		my $DUMMYFH;
		open $DUMMYFH, "$_" || die "Can not open $_: $!\n";
		
		push @file_handles, $DUMMYFH;
		my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)
            = stat $DUMMYFH;
		push @file_sizes,$size;
		}
	}


sub read_marks_file
	{
	if (! $marks_file) {return;}
	print "Trying to get marks_file: $marks_file\n";
	open MFH, "$marks_file" || die "Could not open marks.vdr";
	@marks = <MFH>;
	foreach (@marks)
		{
		print "got mark $_";
		chomp $_;
		my ($h,$m,$s) = split /:/,$_;
		
		my $tick = ($h * 3600 + $m * 60 + $s) * 90000;
		print "secs: $s, got ticks: $tick, in secs: " . ($tick / 90000) ."\n";
		push @ticks,$tick;
		}
	}


sub read_index_file
	{
	open FH,"$index_file" || die "Can not open File: $!\n";
	my $buffer;
	my $bytesread = sysread (FH, $buffer, 10000000);

	my $offset = 0;

	my $I_counter = 0;

	while ($offset < $bytesread)
		{
		my ($c, $Ptype, $number, $reserved) = unpack ("I C C S", substr($buffer, $offset, 8));
		#print "Got $c, $Ptype, $number, $reserved\n";
		$offset += 8;
		#print "offset is $offset\n";
		$I_counter++;
		$Iframes{$I_counter} = "$c : $number" if ($Ptype == 1);
		push @Iframe_list,$I_counter if ($Ptype == 1);
		
		#my $dummy = <STDIN>;
		}
	print "got " . (scalar(keys(%Iframes))) . " I-Frames in this index file...\n";
	return ;
	}


sub get_gop
	{
	my $sec = shift;
	my $gops_to_get = shift;
	my $frame_offset = $sec * 25;
	my ($frameno, $gop_offset) = find_GOP_offset($frame_offset);
	#print "wanted frame $frame_offset, got $frameno at $gop_offset\n";
	#my $dummy = <STDIN>;
	my $counter = $frameno;
	while ($gops_to_get)
		{
		$counter++;
		if (! $Iframes{$counter})
			{
			next;
			}
		else
			{
			$gops_to_get--;
			#print "frame $counter is an Iframe, gops_to_get is $gops_to_get\n";
			}
		}
	my $gop_end = $Iframes{$counter};
	#print "Now we should read the range $gop_offset to $gop_end\n";
	
	my $raw_chunk = ${ read_chunk($gop_offset, $gop_end) };
	#print "rawchunk has a length of " . length($raw_chunk) . "\n";
	my $offset = 0;
	my $video_stream = "";
	my $plength = 0;
	my $packet_counter = 0;
	
	while ($offset + $plength < length($raw_chunk))
		{
		# analyse the needed info from PES Header
		my ($startcode,  $streamcode, $plength, $notused, $header_length) = unpack ( "H6 H2 n1 n1 C1", substr($raw_chunk, $offset, 9));
		
		if ($startcode ne "000001")
			{
			print "No 0x000001 found at current packet, found $startcode and $streamcode instead in packet\n"; exit
			}
		if (! ($streamcode =~/^e/)) 
			{
			#print "video stream $streamcode found\n";
			#print "not a video stream\n";
			$offset +=  $plength + 6;
			next;
			}
		
		if (($offset + $plength) > (length($raw_chunk)))
			{
			die "Did not get a rawchunk back that ends with a packet...\n";
			#print "returning " . length($video_stream) . " bytes of video data\n";
			return \$video_stream;
			}
		
		my $packet = substr($raw_chunk, $offset, ($plength + 6));
		my $payload = (substr($packet, 9 + $header_length));
		$offset +=  $plength + 6;
		$video_stream .= $packet;
		$packet_counter++;
		}
	#print "added $packet_counter packets\n";
	#print "returning " . length($video_stream) . " bytes of video data\n";

#######################################################################################
# TO CHECK WHAT GOING ON UNCOMMENT THE NEXT 3 LINES AND HAVE A LOOK 
# AT THE FILES THAT THIS SCRIPT GENERATES
#######################################################################################

#	open OF, ">./gop$frameno.vdr";
#	print OF $video_stream;
#	close OF;
	return $video_stream, $frameno;
	}

sub read_chunk
	{
	my ($start, $end) = @_;
	($start, my $fileno) = ( split/ : /, $start );
	$fileno--;
	$end = ( split/ : /, $end )[0];
	my $bytes_to_read = $end - $start;
	
	$IFH = $file_handles[$fileno];
	
	
	my $success = (sysseek $IFH, $start, 0);
	#print "seeked to pos $success, $start\n";
	if (!($start == $success))
		{
		print "could not seek, dieing..\n"; die;
		}
	
	my $rbuffer;
	my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;

		if ($rbytes != $bytes_to_read)
			{
				if (! $file_handles[$fileno+1])
				{
					print "Something weird happend, GOP not in files\n";
					exit;
				}
			else
				{
				$IFH = $file_handles[$fileno+1];
				
				my $helpbuffer;
				my $helprbytes = sysread $IFH, $helpbuffer, ($bytes_to_read - length($rbuffer)), 0;
				$rbuffer .= $helpbuffer;
				$rbytes += $helprbytes;
				}
			}
	
	return \$rbuffer;
	}

sub find_GOP_offset
	{
	my $frame = int (shift);
	#print "got frame $frame\n";
	if ($Iframes{$frame})
		{
		#print "Frame $frame is an I-Frame.Returning $Iframes{$frame}\n";
		return ($frame, $Iframes{$frame});
		}
	my $return_frame = 0;
	my $i = 1;
	while ((! $return_frame) && ($i < 10))
		{
		if ($Iframes{$frame - $i})
			{
			#print "Frame $i frames before $frame is an I-Frame. Returning " . ($frame - $i) . " " .$Iframes{$frame - $i} . "\n";
			return ($frame - $i, $Iframes{$frame - $i});
			}
		elsif ($Iframes{$frame + $i})
			{
			#print "Frame $i frames behind $frame is an I-Frame. returning " . ($frame + $i) . " " .$Iframes{$frame + $i} . "\n";
			return ($frame + $i, $Iframes{$frame + $i});
			}
		else
			{
			#print "no iframe found in $i frame distance\n",
			$i++;
			}
		}
	die "could not find a reasonably positioned iframe, exiting\n";
	}




